package apis

import (
	"fmt"

	"github.com/gin-gonic/gin"
	"github.com/go-admin-team/go-admin-core/sdk/api"
	"github.com/go-admin-team/go-admin-core/sdk/pkg/jwtauth/user"
	_ "github.com/go-admin-team/go-admin-core/sdk/pkg/response"

	"go-admin/app/admin/models"
	"go-admin/app/admin/service"
	"go-admin/app/admin/service/dto"
	"go-admin/common/actions"
)

type LineApiUserGroup struct {
	api.Api
}

// GetPage 获取api用户分组列表
// @Summary 获取api用户分组列表
// @Description 获取api用户分组列表
// @Tags api用户分组
// @Param groupName query string false "分组名称"
// @Param pageSize query int false "页条数"
// @Param pageIndex query int false "页码"
// @Success 200 {object} response.Response{data=response.Page{list=[]models.LineApiUserGroup}} "{"code": 200, "data": [...]}"
// @Router /api/v1/line-api-user-group [get]
// @Security Bearer
func (e LineApiUserGroup) GetPage(c *gin.Context) {
	req := dto.LineApiUserGroupGetPageReq{}
	s := service.LineApiUserGroup{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}

	p := actions.GetPermissionFromContext(c)
	list := make([]models.LineApiUserGroup, 0)
	var count int64

	err = s.GetPage(&req, p, &list, &count)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("获取api用户分组失败，\r\n失败信息 %s", err.Error()))
		return
	}

	e.PageOK(list, int(count), req.GetPageIndex(), req.GetPageSize(), "查询成功")
}

// Get 获取api用户分组
// @Summary 获取api用户分组
// @Description 获取api用户分组
// @Tags api用户分组
// @Param id path int false "id"
// @Success 200 {object} response.Response{data=models.LineApiUserGroup} "{"code": 200, "data": [...]}"
// @Router /api/v1/line-api-user-group/{id} [get]
// @Security Bearer
func (e LineApiUserGroup) Get(c *gin.Context) {
	req := dto.LineApiUserGroupGetReq{}
	s := service.LineApiUserGroup{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}
	var object models.LineApiUserGroup

	p := actions.GetPermissionFromContext(c)
	err = s.Get(&req, p, &object)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("获取api用户分组失败，\r\n失败信息 %s", err.Error()))
		return
	}

	e.OK(object, "查询成功")
}

// Insert 创建api用户分组
// @Summary 创建api用户分组
// @Description 创建api用户分组
// @Tags api用户分组
// @Accept application/json
// @Product application/json
// @Param data body dto.LineApiUserGroupInsertReq true "data"
// @Success 200 {object} response.Response	"{"code": 200, "message": "添加成功"}"
// @Router /api/v1/line-api-user-group [post]
// @Security Bearer
func (e LineApiUserGroup) Insert(c *gin.Context) {
	req := dto.LineApiUserGroupInsertReq{}
	s := service.LineApiUserGroup{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}
	// 设置创建人
	req.SetCreateBy(user.GetUserId(c))

	if err := req.Valid(); err != nil {
		e.Error(500, err, err.Error())
		return
	}

	err = s.Insert(&req)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("创建api用户分组失败，\r\n失败信息 %s", err.Error()))
		return
	}

	e.OK(req.GetId(), "创建成功")
}

// Update 修改api用户分组
// @Summary 修改api用户分组
// @Description 修改api用户分组
// @Tags api用户分组
// @Accept application/json
// @Product application/json
// @Param id path int true "id"
// @Param data body dto.LineApiUserGroupUpdateReq true "body"
// @Success 200 {object} response.Response	"{"code": 200, "message": "修改成功"}"
// @Router /api/v1/line-api-user-group/{id} [put]
// @Security Bearer
func (e LineApiUserGroup) Update(c *gin.Context) {
	req := dto.LineApiUserGroupUpdateReq{}
	s := service.LineApiUserGroup{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}
	req.SetUpdateBy(user.GetUserId(c))
	p := actions.GetPermissionFromContext(c)

	if err := req.Valid(); err != nil {
		e.Error(500, err, err.Error())
		return
	}

	err = s.Update(&req, p)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("修改api用户分组失败，\r\n失败信息 %s", err.Error()))
		return
	}
	e.OK(req.GetId(), "修改成功")
}

// Delete 删除api用户分组
// @Summary 删除api用户分组
// @Description 删除api用户分组
// @Tags api用户分组
// @Param data body dto.LineApiUserGroupDeleteReq true "body"
// @Success 200 {object} response.Response	"{"code": 200, "message": "删除成功"}"
// @Router /api/v1/line-api-user-group [delete]
// @Security Bearer
func (e LineApiUserGroup) Delete(c *gin.Context) {
	s := service.LineApiUserGroup{}
	req := dto.LineApiUserGroupDeleteReq{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}

	// req.SetUpdateBy(user.GetUserId(c))
	p := actions.GetPermissionFromContext(c)

	err = s.Remove(&req, p)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("删除api用户分组失败，\r\n失败信息 %s", err.Error()))
		return
	}
	e.OK(req.GetId(), "删除成功")
}

func (e LineApiUserGroup) GetOptions(c *gin.Context) {
	s := service.LineApiUserGroup{}
	req := dto.LineApiUserGroupGetOptionsReq{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}

	p := actions.GetPermissionFromContext(c)
	var datas []dto.LineApiUserGroupOptions
	if err = s.GetOptions(&req, &datas, p); err != nil {
		e.Error(500, err, "")
		return
	}
	e.OK(datas, "查询成功")
}
